Magellan Linux

Diff of /branches/mage-next/src/smage2.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

trunk/mage/usr/lib/mage/smage2.sh revision 33 by niro, Thu Jan 6 02:57:12 2005 UTC branches/mage-next/src/smage2.in revision 3035 by niro, Fri Jun 30 12:11:53 2017 UTC
# Line 1  Line 1 
1  #!/bin/bash  #!/bin/bash
2    # $Id$
3    
4  # compiles/installs .smage2 source install scripts  # compiles/installs .smage2 source install scripts
5  # needs pkgbuild_dir (mage)  # needs pkgbuild_dir (mage)
6    
7  # SMAGE2  # TODO: record dynlib, gz | xz database
 # version: 0.3.6-r9  
8    
9  #01.10.2004  
10  # added ccache support  # set default variables
11  # added distcc support  : ${MAGERC="@@SYSCONFDIR@@/mage.rc"}
12    : ${MLIBDIR="@@MAGELIBDIR@@"}
13    
14    # export default C locale
15    export LC_ALL=C
16    
17    # first of all include common functions
18    source ${MLIBDIR}/common.functions.sh || exit 1
19    source @@SYSCONFDIR@@/mage.rc.global || die "@@SYSCONFDIR@@/mage.rc.global missing."
20    source ${MAGERC} || die "${MAGERC} missing."
21    source ${MLIBDIR}/mage4.functions.sh || die "${MLIBDIR}/mage4.functions.sh missing."
22    source ${MLIBDIR}/smage2.functions.sh || die "${MLIBDIR}/smage2.functions.sh missing."
23    
24    # export default path
25    export PATH="${PATH}:${MLIBDIR}"
26    
27    print_usage()
28    {
29     echo "Usage: $(basename $0) [option] pkgname ..."
30     echo "Options:"
31     echo "--smage"
32     echo "--src-tarball"
33     echo "--calc"
34     echo "--update"
35     echo "--download"
36     echo "--regen"
37     echo "--create-src-tarball"
38     echo "--resume"
39     echo
40     echo "Environment variables::"
41     echo " NOCOLORS=true $(basename $0) [src]install PACKAGE"
42     echo " Disables all colors in the messages."
43     echo
44    }
45    
46    # very basic getops
47    for i in $*
48    do
49     case $1 in
50     --smage|*.${SMAGESUFFIX}) shift; SMAGENAME="$1" ;;
51     --src-tarball) shift; SRCPKGTARBALL="$1" ;;
52     --calc) shift; SMAGENAME="$1" ;;
53     --update) ;;
54     --download) shift; SMAGENAME="$1" ;;
55     --regen) shift; SMAGENAME="$1" ;;
56     --create-src-tarball) shift; SMAGENAME="$1" ;;
57     --resume) ;;
58     esac
59     shift
60    done
61    
62  ## setup ##  ## setup ##
 SMAGEVERSION=0.3.6-r8  
 PKGSUFFIX="mpk"  
63  SMAGENAME="$1"  SMAGENAME="$1"
 SMAGESUFFIX="smage2"  
 #SOURCEDIR="/bootstrap/sources"  
 #SMAGESCRIPTSDIR="/bootstrap/smage2-install-scripts"  
 #SMAGE2RSYNC="rsync://192.168.0.2/smage2-scripts"  
 MLIBDIR=/usr/lib/mage  
   
 source /etc/mage.rc  
   
 showversion() {  
  echo -en "Magellan Source Install v${SMAGEVERSION} "  
  echo -e  "-- Niels Rogalla (niro@magellan-linux.de)"  
 }  
64    
65  die() {  # expand PKGDIR, BUILDDIR and BINDIR with MROOT
66   xtitleclean  if [[ -n ${MROOT} ]]
67   echo "SMAGE failed: $@"  then
68     export PKGDIR=${MROOT}/${PKGDIR}
69     export BUILDDIR=${MROOT}/${BUILDDIR}
70     export BINDIR=${MROOT}/${BINDIR}
71    fi
72    
73    # print out our version
74    showversion
75    echo
76    
77    if [[ -z ${SMAGENAME} ]]
78    then
79     echo "No .smage2 file given. Exiting."
80     echo
81   exit 1   exit 1
82  }  fi
83    
84  xtitle() {  # load supported mage features
85   if [ ${TERM} == "xterm" ]  load_mage_features
  then  
  echo -ne "\033]0;[sMage: $@]\007"  
  fi  
  return 0  
 }  
86    
87  xtitleclean() {  # updating smage2-scripts
88   if [ ${TERM} == "xterm" ]  if [[ $1 = update ]]
89    then
90     if [ ! -d ${SOURCEDIR} ]
91   then   then
92   echo -ne "\033]0;\007"   install -d ${SOURCEDIR}
93   fi   fi
94   return 0   syncsmage2
95  }   exit 0
96    fi
97    
98  syncsmage2() {  # creates md5sums for smages to given dir
99   xtitle "Updating smage2-script tree ..."  if [[ $1 = calcmd5 ]]
100   local i  then
101   for i in ${SMAGE2RSYNC}   if [ $# -ge 2 ]
102   do   then
103   rsync \   SMAGENAME="$2"
104   --recursive \   MD5DIR="$3"
105   --links \   [[ -z ${MD5DIR} ]] && MD5DIR="$(dirname ${SMAGENAME})/md5"
  --perms \  
  --times \  
  --devices \  
  --timeout=600 \  
  --verbose \  
  --compress \  
  --progress \  
  --stats \  
  --delete \  
  --delete-after \  
  ${i} ${SMAGESCRIPTSDIR}  
   
  if [ "$?" == "0" ]  
  then  
  break  
  else  
  continue  
  fi  
   
  done  
   
  #clean up backup files (foo~)  
  find ${SMAGESCRIPTSDIR} -name *~ -exec rm '{}' ';'  
   
  xtitleclean  
 }  
106    
107  # dummy function, used if that not exist in smage file   smagesource ${SMAGENAME} || die "download source failed"
 src_prepare() {  
  echo "no src_prepare defined"  
  sleep 2  
  return 0  
 }  
108    
109  # dummy function, used if that not exist in smage file   # overridable sourcedir; must be declared after source of the smage2
110  src_compile() {   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"
  echo "no src_compile defined"  
  sleep 2  
  return 0  
 }  
111    
112  # dummy function, used if that not exist in smage file   [ -z "${SRC_URI}" ] && die "Nothing declared to calculate."
 src_install() {  
  echo "no src_install defined"  
  sleep 2  
  return 0  
 }  
113    
114     # end of array
115     EOA=${#SRC_URI[*]}
116    
117  build_mage_script() {   [ ! -d ${MD5DIR} ] && install -d ${MD5DIR}
  return 0  
 }  
118    
119  mconfigure() {   # clear md5sum file
120   if [ -x ./configure ]   MY_MD5_FILE="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"
121   then   echo -n > ${MY_MD5_FILE}
  ./configure \  
  --prefix=/usr \  
  --host=${CHOST} \  
  --mandir=/usr/share/man \  
  --infodir=/usr/share/info \  
  --datadir=/usr/share \  
  --sysconfdir=/etc \  
  --localstatedir=/var/lib \  
  "$@" || die "mconfigure failed"  
  else  
  echo "configure is not an executable ..."  
  exit 1  
  fi  
 }  
122    
123  minstall() {   for ((i=0; i < EOA; i++))
124   if [ -f ./[mM]akefile -o -f ./GNUmakefile ] ; then   do
125   make prefix=${BINDIR}/usr \   # url to file
126   datadir=${BINDIR}/usr/share \   my_SRC_URI="$(echo ${SRC_URI[${i}]} | cut -d' ' -f1)"
  infodir=${BINDIR}/usr/share/info \  
  localstatedir=${BINDIR}/var/lib \  
  mandir=${BINDIR}/usr/share/man \  
  sysconfdir=${BINDIR}/etc \  
  "$@" install || die "minstall failed"  
         else  
                 die "no Makefile found"  
         fi  
 }  
127    
128  mmake() {   # subdir in sources dir; the my_SRCI_URI file goes to there
129   make ${MAKEOPTS} ${EXTRA_EMAKE} "$@"   my_SRC_URI_DEST="$(echo ${SRC_URI[${i}]} | cut -d' ' -f2)"
 }  
130    
131  munpack() {   # if my_src_uri_dest is not equal my_src_uri; than an other dir is used
132   local SRCFILE   if [[ ${my_SRC_URI_DEST} != ${my_SRC_URI} ]]
  local IFTAR  
  local DEST  
   
  SRCFILE=$1  
   
  if [ -z "$2" ]  
  then  
  DEST=${BUILDDIR}  
  else  
  DEST=$2  
  fi  
   
  case "${SRCFILE##*.}" in  
  bz2)  
  IFTAR="$(basename $SRCFILE .bz2)"  
  IFTAR="${IFTAR##*.}"  
  if [ "${IFTAR}" == "tar" ]  
133   then   then
134   tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}   MY_SRC_FILE="${my_SRC_URI_DEST}/$(basename ${SRC_URI[${i}]})"
135     else
136     MY_SRC_FILE="$(basename ${SRC_URI[${i}]})"
137   fi   fi
138   ;;  
139   gz)   if [ -e "${CALC_SOURCEDIR}/${MY_SRC_FILE}" ]
  IFTAR="$(basename $SRCFILE .gz)"  
  IFTAR="${IFTAR##*.}"  
  if [ "${IFTAR}" == "tar" ]  
140   then   then
141   tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}   echo "calculating $(basename ${MY_SRC_FILE}) ..."
142     ( cd ${CALC_SOURCEDIR}; md5sum "${MY_SRC_FILE}" ) >> ${MY_MD5_FILE}
143     else
144     echo "WARNING: File '$(basename ${MY_SRC_FILE}) not found in ${CALC_SOURCEDIR}."
145   fi   fi
146   ;;  
147   tbz2)   # unset them to be shure
148   tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}   unset my_SRC_URI
149   ;;   unset my_SRC_URI_DEST
150   tgz)   unset my_SRC_URI_MIRROR
151   tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}   unset my_SOURCEDIR
152   ;;   done
153   *)  
154   die "munpack failed"   echo
155   ;;   echo "Calculating of md5 sums for '$(basename ${SMAGENAME} .${SMAGESUFFIX})' done."
156   esac   echo
157  }   else
158     echo "Usage: Calculating MD5 Sums:"
159  mpatch() {   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME [/path/to/MD5DIR]"
160   local PATCHOPTS   echo
161   local PATCHFILE   echo
162     echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."
163   PATCHOPTS=$1   echo
164   PATCHFILE=$2   exit 1
165     fi
  patch "${PATCHOPTS}" -i ${SOURCEDIR}/${PNAME}/${PATCHFILE}  
 }  
   
166    
167  minstalldocs() {   exit 0
168   local docfiles  fi
   
  docfiles="$@"  
   
  if [ ! -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} ]  
  then  
  install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."  
  fi  
   
  for i in ${docfiles}  
  do  
  cat ${i} | gzip -9c > ${i}.gz || die "gzipping docs."  
  install -m 0644 ${SRCDIR}/${i}.gz \  
  ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "coping docs."  
  done  
 }  
169    
170  setup_distcc_environment(){  # download sources
171   if [ -x /usr/bin/distcc ]  if [ "$1" == "download" -a -n "$2" ]
172    then
173     if [ ! -d ${SMAGESCRIPTSDIR} ]
174   then   then
175   echo "Using DistCC for compilation ..."   install -d ${SMAGESCRIPTSDIR}
176   export PATH=/usr/lib/distcc/bin:${PATH} || die "distcc: could not export new $PATH"   fi
177    
178     # get smage
179     SMAGENAME="$2"
180     MD5DIR="$(dirname ${SMAGENAME})/md5"
181     smagesource ${SMAGENAME} || die "download source failed"
182    
183   #export distcc as compiler   download_sources
184  # export CC="distcc"   exit 0
185  # export CXX=distcc  fi
186    
187   export DISTCC_DIR="${DISTCC_DIR}" || die "distcc_dir export failed"  # regen-mage-tree
188    if [ "$1" == "only-regen-tree" -a -n "$2" ]
189    then
190     # set correct SMAGENAME
191     SMAGENAME="$2"
192     MD5DIR="$(dirname ${SMAGENAME})/md5"
193     smagesource ${SMAGENAME} || die "regen: smage2 not found"
194    
195     regen_mage_tree
196    
197   #ccache + distcc together   # build several subpackages
198   if [ "${SMAGE_USE_CCACHE}" == "true" ]   if [[ -n ${SPLIT_PACKAGES} ]]
199   then   then
200   if [ -x /usr/bin/ccache ]   split_save_variables
201     for subpackage in ${SPLIT_PACKAGES}
202     do
203     # get the right variables for the split
204     export PNAME="${subpackage}"
205     split_info_${subpackage}
206     # fix PCATEGORIE -> PCAT
207     if [[ ! -z ${PCATEGORIE} ]]
208   then   then
209   echo "Preparing DistCC to work together with CCache ..."   PCAT="${PCATEGORIE}"
210   #export CCACHE_PREFIX="distcc" || die "distcc: could not set ccach_prefix"   unset PCATEGORIE
 # export CC="ccache distcc"  
 # export CXX="ccache distcc"  
211   fi   fi
212   fi   # build md5sum for existing packages
213     generate_package_md5sum \
214   #creating distcc tempdir   --pcat "${PCAT}" \
215   install -o distcc -g daemon -d ${DISTCC_DIR}   --pname "${PNAME}" \
216   chmod 1777 ${DISTCC_DIR}   --pver "${PVER}" \
217   fi   --pbuild "${PBUILD}" \
218  }   --parch "${ARCH}"
219     # restore smage environment
220     split_restore_variables
221     done
222     # unset all saved smage variables
223     split_unset_variables
224    
225  setup_ccache_environment(){   else
226   if [ -x /usr/bin/ccache ]   # build md5sum for existing packages
227   then   generate_package_md5sum \
228   echo "Using CCache for compilation ..."   --pcat "${PCAT}" \
229   export PATH=/usr/lib/ccache/bin:${PATH} || die "ccache: could not export new $PATH"   --pname "${PNAME}" \
230   #unset CC CXX   --pver "${PVER}" \
231     --pbuild "${PBUILD}" \
232     --parch "${ARCH}"
233   fi   fi
 }  
234    
235  if [ -z "$1" ]   exit 0
 then  
  showversion  
  echo  
  echo "No .smage2 file given. Exiting."  
  echo  
  exit 1  
236  fi  fi
237    
238  #updating smage2-scripts  if [ "$1" == "--create-src-tarball" -a -n "$2" ]
 if [ "$1" == "update" ]  
239  then  then
240   showversion   # set correct SMAGENAME
241   if [ ! -d ${SMAGESCRIPTSDIR} ]   SMAGENAME="$2"
242     MD5DIR="$(dirname ${SMAGENAME})/md5"
243    
244     echo -e "${COLGREEN}create-src-tarball called for ${COLBLUE}${SMAGENAME}${COLGREEN} ...${COLDEFAULT}"
245    
246     smagesource ${SMAGENAME} || die "regen: smage2 not found"
247    
248     if [[ -d ${SOURCEDIR}/${PNAME} ]]
249   then   then
250   install -d ${SMAGESCRIPTSDIR}   echo -e "${COLGREEN}Deleting old sourcefiles ${COLBLUE}${SOURCEDIR}/${PNAME}${COLGREEN} ...${COLDEFAULT}"
251     rm -rf ${SOURCEDIR}/${PKGNAME}
252   fi   fi
253   syncsmage2  
254     download_sources
255     source_pkg_build ${SMAGENAME}
256   exit 0   exit 0
257  fi  fi
258    
259    if [ "$1" == "--src-tarball" -a -n "$2" ] || [ "$1" == "-st" -a -n "$2" ]
 if [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ]  
260  then  then
261   die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."   SRCPKGTARBALL="${2}"
262  fi   msetfeature "srcpkgtarball"
263    
264  if [ -z "`basename ${SMAGENAME}|grep .${SMAGESUFFIX}`" ]   # abort if given file is not a source pkg
265  then   [[ ${SRCPKGTARBALL##*.} != ${SRCPKGSUFFIX} ]] && die "${SRCPKGTARBALL} is not a valid src-pkg file."
  die "File '`basename ${SMAGENAME}`' is not a sMage v${SMAGEVERSION} file. Aborting."  
 fi  
266    
267  if [ -z "${SOURCEDIR}" ]   # set correct SMAGENAME; use the one that the src_pkg provide
268  then   # /path/to/SOURCEDIR/PNAME/SMAGENAME
269   die "\$SOURCEDIR not found. Please setup your mage.rc correctly."   SMAGENAME="${SOURCEDIR}/$(basename ${SRCPKGTARBALL%-*-*})/$(basename ${SRCPKGTARBALL} .${SRCPKGSUFFIX}).${SMAGESUFFIX}"
 fi  
270    
271  if [ -z "${SMAGESCRIPTSDIR}" ]   echo -e "${COLGREEN}Using src-tarball ${COLBLUE}${SRCPKGTARBALL}${COLGREEN} ...${COLDEFAULT}"
 then  
  die "\$SMAGESCRIPTSDIR not found. Please setup your mage.rc correctly."  
 fi  
272    
273  if [ -z "${SMAGE2RSYNC}" ]   [[ ! -d ${SOURCEDIR} ]] && install -d ${SOURCEDIR}
 then  
  echo "\$SMAGE2RSYNC not found. Please setup your mage.rc correctly."  
  exit 1  
 fi  
274    
275  if [ -z "${BINDIR}" ]   # unpack srctarball
276  then   [[ ! -f ${SRCPKGTARBALL} ]] && die "Error: ${SRCPKGTARBALL} does not exist. Aborting."
  die "no BINDIR variable found in /etc/mage.rc"  
 fi  
277    
278  if [ -z "${CHOST}" ]   tar xvjf ${SRCPKGTARBALL} -C ${SOURCEDIR} || die  "Error unpackung src-tarball ${SRCPKGTARBALL}"
 then  
  die "no CHOST variable found in /etc/mage.rc"  
 fi  
279    
280  if [ -z "${CFLAGS}" ]   [[ ! -f ${SMAGENAME} ]] && die "Included smage2 file in src-tarball not found: ${SMAGENAME}"
 then  
  die "no CFLAGS variable found in /etc/mage.rc"  
281  fi  fi
282    
283  if [ -z "${CXXFLAGS}" ]  if [ "$1" == "--resume" -a -n "$2" ]
284  then  then
285   die "no CXXFLAGS variable found in /etc/mage.rc"   msetfeature "resume"
286     SMAGENAME="$2"
287  fi  fi
288    
289    [ ! -e ${MLIBDIR}/pkgbuild_dir ] && die "Error: ${MLIBDIR}/pkgbuild_dir not found. Aborting."
290    [ -z "$(basename ${SMAGENAME} | grep .${SMAGESUFFIX})" ] &&
291     die "File '$(basename ${SMAGENAME})' is not a sMage v${SMAGEVERSION} file. Aborting."
292    [ -z "${SOURCEDIR}" ] && die "\$SOURCEDIR not found. Please setup your ${MAGERC} correctly."
293    [ -z "${SMAGESCRIPTSDIR}" ] && die "\$SMAGESCRIPTSDIR not found. Please setup your ${MAGERC} correctly."
294    [ -z "${SMAGE2RSYNC}" ] && die "\$SMAGE2RSYNC not found. Please setup your ${MAGERC} correctly."
295    [ -z "${BINDIR}" ] && die "no BINDIR variable found in ${MAGERC}"
296    [ -z "${CHOST}" ] && die "no CHOST variable found in ${MAGERC}"
297    [ -z "${CFLAGS}" ] && die "no CFLAGS variable found in ${MAGERC}"
298    [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in ${MAGERC}"
299    
300  source ${SMAGENAME} || die "source failed"  smagesource ${SMAGENAME} || die "source failed"
301  PKGNAME="${PNAME}-${PVER}-${CHOST%%-*}-${PBUILD}"  PKGNAME="${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}"
302    MD5DIR="$(dirname ${SMAGENAME})/md5"
303    SMAGE_LOG_CMD="tee -a ${SMAGELOGDIR}/${PKGNAME}.log"
304    
305  xtitle "Compiling ${PKGNAME}"  xtitle "Compiling ${PKGNAME}"
306  #fixes some issues with these functions  echo -e "${COLGREEN}Compiling ${PKGNAME}${COLDEFAULT}"
307    
308    if mqueryfeature "srcpkgbuild"
309    then
310     if [[ -d ${SOURCEDIR}/${PNAME} ]]
311     then
312     echo -e "${COLBLUE}===${COLGREEN} deleting old sourcefiles ${COLBLUE}${SOURCEDIR}/${PNAME}${COLGREEN} ...${COLDEFAULT}"
313     rm -rf ${SOURCEDIR}/${PNAME}
314     fi
315    fi
316    
317    # download sources
318    mqueryfeature "srcpkgtarball" || download_sources
319    
320    # fixes some issues with these functions
321    export -f pkg_setup || die "pkg_setup export failed"
322  export -f src_prepare || die "src_prepare export failed"  export -f src_prepare || die "src_prepare export failed"
323  export -f src_compile || die "src_compile export failed"  export -f src_compile || die "src_compile export failed"
324    export -f src_check || die "src_check export failed"
325  export -f src_install || die "src_install export failed"  export -f src_install || die "src_install export failed"
326    
327  #fixes some compile issues  # fixes some compile issues
328  export CHOST="${CHOST}" || die "CHOST export failed"  export CHOST="${CHOST}" || die "CHOST export failed"
329    export CPPFLAGS="${CPPFLAGS}" || die "CPPFLAGS export failed"
330  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"
331  export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"  if [[ -z ${CXXFLAGS} ]]
332    then
333     export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"
334    else
335     export CXXFLAGS="${CXXFLAGS}" || die "CXXFLAGS export failed"
336    fi
337    export LDFLAGS="${LDFLAGS}" || die "LDFLAGS export failed"
338  export BINDIR="${BINDIR}" || die "BINDIR export failed"  export BINDIR="${BINDIR}" || die "BINDIR export failed"
339  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"
340    
341    # setup distcc
342    # setup for distcc goes *before* ccache, so ccache comes before distcc in path
343    mqueryfeature "distcc" && setup_distcc_environment
344    
345  #setup distcc  # setup icecc
346  #distcc mus be setup *before* ccache, as ccache need to be before distcc in path  # setup for icecc goes *before* ccache, so ccache comes before icecc in path
347  if [ "${SMAGE_USE_DISTCC}" == "true" ]  mqueryfeature "icecc" && setup_icecc_environment
348  then  
349   setup_distcc_environment  # setup ccache
350  fi  mqueryfeature "ccache" && setup_ccache_environment
351    
352  #setup ccache  if mqueryfeature "resume"
 if [ "${SMAGE_USE_CCACHE}" == "true" ]  
353  then  then
354   setup_ccache_environment   echo -e "${COLMAGENTA}Resume requested; continuing previous build${COLDEFAULT}"
 fi  
355    
356     # setup build logging
357     [[ ! -d ${SMAGELOGDIR} ]] && install -d ${SMAGELOGDIR}
358     if [[ -f ${SMAGELOGDIR}/${PKGNAME}.log.bz2 ]]
359     then
360     bunzip2 -f ${SMAGELOGDIR}/${PKGNAME}.log.bz2
361     fi
362     echo -e "### Resume started on $(date) ###\n" >> ${SMAGELOGDIR}/${PKGNAME}.log
363    
364  # small sleep to show our settings  else
365  sleep 1   # clean up builddir if a previously one exist
366     if [ -d ${BUILDDIR} ]
367     then
368     rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."
369     fi
370     install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."
371    
372  #debug   # clean up srcdir if a previously unpacked one exist
373  #echo "CC=${CC}"   if [ -d ${SRCDIR} ]
374  #echo "CXX=${CXX}"   then
375  #echo "DISTCC_DIR=${DISTCC_DIR}"   rm -rf ${SRCDIR}
376  #echo "PATH: ${PATH}"   fi
 #echo "--------------------------------------"  
 #env  
 #echo "--------------------------------------"  
 #read  
 #debug end  
377    
378  #cleans up build if a previously one exists   # clean up bindir if a previous build exist or create a new one
379  if [ -d ${BUILDDIR} ]   if [ -d ${BINDIR} ]
380  then   then
381   rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."   rm -rf ${BINDIR}
382     fi
383     install -d ${BINDIR} || die "couldn't create \$BINDIR."
384    
385     # clean up package temp dir if a previous build exist
386     if [ -d ${BUILDDIR}/${PKGNAME} ]
387     then
388     rm -rf ${BUILDDIR}/${PKGNAME}
389     fi
390    
391     # clean up stamps dir
392     if [ -d ${BUILDDIR}/.stamps ]
393     then
394     rm -rf ${BUILDDIR}/.stamps
395     fi
396    
397     # setup build logging
398     [[ ! -d ${SMAGELOGDIR} ]] && install -d ${SMAGELOGDIR}
399     echo -e "### Build started on $(date) ###\n" > ${SMAGELOGDIR}/${PKGNAME}.log
400    fi
401    
402    if [[ ${PKGTYPE} = virtual ]]
403    then
404     echo "virtual package detected; nothing will be build ..."
405     # automatically set !pkgbuild here too
406     msetfeature "!pkgbuild"
407    else
408     ( run_resume pkg_setup || pkg_setup ) |& ${SMAGE_LOG_CMD}
409     die_pipestatus 0 "pkg_setup failed"
410     resume_stamp pkg_setup
411     step_by_step pkg_setup
412    
413     ( run_resume src_prepare || src_prepare ) |& ${SMAGE_LOG_CMD}
414     die_pipestatus 0 "src_prepare failed"
415     resume_stamp src_prepare
416     step_by_step src_prepare
417    
418     ( run_resume src_compile || src_compile ) |& ${SMAGE_LOG_CMD}
419     die_pipestatus 0 "src_compile failed"
420     resume_stamp src_compile
421     step_by_step src_compile
422    
423     # only run checks if requested
424     if mqueryfeature "!check"
425     then
426     echo "!check detected; src_check() will not be run!" |& ${SMAGE_LOG_CMD}
427     else
428     ( run_resume src_check || src_check ) |& ${SMAGE_LOG_CMD}
429     die_pipestatus 0 "src_check failed"
430     resume_stamp src_check
431     fi
432     step_by_step src_check
433    
434     # build several subpackages
435     if [[ -n ${SPLIT_PACKAGES} ]]
436     then
437     # save bindir & pname
438     split_save_variables
439     export SAVED_BINDIR="${BINDIR}"
440     for subpackage in ${SPLIT_PACKAGES}
441     do
442     split_info_${subpackage}
443     if [[ ${PKGTYPE} = virtual ]]
444     then
445     echo
446     echo -en "${COLBLUE}*** ${COLDEFAULT}"
447     echo -en "Virtual package detected"
448     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
449     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
450    
451     echo "virtual package detected; nothing will be build ..."
452     # automatically set !pkgbuild here too
453     msetfeature "!pkgbuild"
454     else
455     if typeset -f src_install_${subpackage} > /dev/null
456     then
457     # export subpackage bindir
458     export BINDIR="${SAVED_BINDIR}_${subpackage}"
459     # export PNAME, several internal function and include
460     # rely on this variable
461     export PNAME="${subpackage}"
462    
463     echo
464     echo -en "${COLBLUE}*** ${COLDEFAULT}"
465     echo -en "Running ${COLGREEN}split src_install()${COLDEFAULT}"
466     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
467     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
468    
469     ( run_resume src_install_${subpackage} || src_install_${subpackage} ) |& ${SMAGE_LOG_CMD}
470     die_pipestatus 0 "src_install_${subpackage} failed"
471     resume_stamp src_install_${subpackage}
472     step_by_step src_install_${subpackage}
473     fi
474     fi
475     # restore smage environment
476     split_restore_variables
477     done
478     # unset all saved smage variables
479     split_unset_variables
480     else
481     ( run_resume src_install || src_install ) |& ${SMAGE_LOG_CMD}
482     die_pipestatus 0 "src_install failed"
483     resume_stamp src_install
484     step_by_step src_install
485     fi
486  fi  fi
 install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."  
487    
488  #cleans up srcdir if a previously unpacked one exists  # echo for sake of good-looking
489  if [ -d ${SRCDIR} ]  echo
490    
491    if mqueryfeature "!compressdoc"
492    then
493     echo -e "!compressdoc detected; documentation will not be compressed ..."
494    elif mqueryfeature "!pkgbuild"
495  then  then
496   rm -rf ${SRCDIR}   echo "!pkgbuild detected; skipping documentation compression..."
497    else
498     # compressing doc, info & man files
499     if [[ -n ${SPLIT_PACKAGES} ]]
500     then
501     # save smage environment
502     split_save_variables
503     for subpackage in ${SPLIT_PACKAGES}
504     do
505     # honor split_info
506     split_info_${subpackage}
507     if [[ ${PKGTYPE} = virtual ]]
508     then
509     # automatically set !pkgbuild here too
510     msetfeature "!pkgbuild"
511     fi
512    
513     if mqueryfeature "!compressdoc"
514     then
515     echo -e "!compressdoc detected; documentation of '${subpackage}' will not be compressed ..."
516     elif mqueryfeature "!pkgbuild"
517     then
518     echo "!pkgbuild detected; skipping documentation compression for '${subpackage}' ..."
519     else
520     run_resume post-mcompressdoc_${subpackage} || mcompressdocs ${BINDIR}_${subpackage}
521     resume_stamp post-mcompressdoc_${subpackage}
522     fi
523     # restore smage environment
524     split_restore_variables
525     done
526     # unset saved variables
527     split_unset_variables
528     else
529     run_resume post-mcompressdoc || mcompressdocs ${BINDIR}
530     resume_stamp post-mcompressdoc
531     fi
532  fi  fi
533    
534  #cleans up bindir if a previous build exists or creates a new one  if mqueryfeature "!libtool"
 if [ -d ${BINDIR} ]  
535  then  then
536   rm -rf ${BINDIR}   if mqueryfeature "!pkgbuild"
537     then
538     echo "!pkgbuild detected; skipping libtool archive stripping ..."
539     else
540     if [[ -n ${SPLIT_PACKAGES} ]]
541     then
542     # save smage environment
543     split_save_variables
544     for subpackage in ${SPLIT_PACKAGES}
545     do
546     # honor split_info
547     split_info_${subpackage}
548     if [[ ${PKGTYPE} = virtual ]]
549     then
550     # automatically set !pkgbuild here too
551     msetfeature "!pkgbuild"
552     fi
553    
554     if mqueryfeature "!libtool"
555     then
556     if mqueryfeature "!pkgbuild"
557     then
558     echo "!pkgbuild detected; skipping libtool archive stripping for '${subpackage}'..."
559     else
560     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives for '${subpackage}' ...${COLDEFAULT}"
561     run_resume post-mstriplibtoolarchive_${subpackage} || mstriplibtoolarchive ${BINDIR}_${subpackage}
562     resume_stamp post-mstriplibtoolarchive_${subpackage}
563     fi
564     fi
565    
566     # restore smage environment
567     split_restore_variables
568     done
569     # unset saved variables
570     split_unset_variables
571     else
572     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives ...${COLDEFAULT}"
573     run_resume post-mstriplibtoolarchive || mstriplibtoolarchive ${BINDIR}
574     resume_stamp post-mstriplibtoolarchive
575     fi
576     fi
577  fi  fi
 install -d ${BINDIR} || die "couldn't create \$BINDIR."  
578    
579  #cleans up package temp dir if a previous build exists  if mqueryfeature "purge"
 if [ -d ${BUILDDIR}/${PKGNAME} ]  
580  then  then
581   rm -rf ${BUILDDIR}/${PKGNAME}   if mqueryfeature "!pkgbuild"
582     then
583     echo "!pkgbuild detected; skipping file purgation ..."
584     else
585     if [[ -n ${SPLIT_PACKAGES} ]]
586     then
587     # save smage environment
588     split_save_variables
589     for subpackage in ${SPLIT_PACKAGES}
590     do
591     # honor split_info
592     split_info_${subpackage}
593     if [[ ${PKGTYPE} = virtual ]]
594     then
595     # automatically set !pkgbuild here too
596     msetfeature "!pkgbuild"
597     fi
598    
599     if mqueryfeature "purge"
600     then
601     if mqueryfeature "!pkgbuild"
602     then
603     echo "!pkgbuild detected; skipping file purgation for '${subpackage}' ..."
604     else
605     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets in '${subpackage}' ...${COLDEFAULT}"
606     run_resume post-mpurgetargets_${subpackage} || mpurgetargets ${BINDIR}_${subpackage}
607     resume_stamp post-mpurgetargets_${subpackage}
608     fi
609     fi
610    
611     # restore smage environment
612     split_restore_variables
613     done
614     # unset saved variables
615     split_unset_variables
616     else
617     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets ...${COLDEFAULT}"
618     run_resume post-mpurgetargets || mpurgetargets ${BINDIR}
619     resume_stamp post-mpurgetargets
620     fi
621     fi
622  fi  fi
623    
624  #cleans up timestamp if one exists  # stripping all bins and libs
625  if [ -f /var/tmp/timestamp ]  if mqueryfeature "!strip"
626  then  then
627   mage rmstamp   echo -e "!strip detected; package will not be stripped ..."
628  fi  elif mqueryfeature "!pkgbuild"
629    then
630     echo "!pkgbuild detected; skipping stripping of the package ..."
631    else
632     if [[ -n ${SPLIT_PACKAGES} ]]
633     then
634     # save smage environment
635     split_save_variables
636     for subpackage in ${SPLIT_PACKAGES}
637     do
638     # honor split_info
639     split_info_${subpackage}
640     if [[ ${PKGTYPE} = virtual ]]
641     then
642     # automatically set !pkgbuild here too
643     msetfeature "!pkgbuild"
644     fi
645    
646  src_prepare || die "src_prepare failed"   if mqueryfeature "!strip"
647  src_compile || die "src_compile failed"   then
648  src_install || die "src_install failed"   echo -e "!strip detected; package '${subpackage}' will not be stripped ..."
649     elif mqueryfeature "!pkgbuild"
650     then
651     echo "!pkgbuild detected; skipping stripping of the package '${subpackage}' ..."
652     else
653     echo -e "${COLBLUE}===${COLGREEN} stripping binaries for '${subpackage}' ...${COLDEFAULT}"
654     run_resume post-mstripbins_${subpackage} || mstripbins ${BINDIR}_${subpackage}
655     resume_stamp post-mstripbins_${subpackage}
656     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries for '${subpackage}' ...${COLDEFAULT}"
657     run_resume post-mstriplibs_${subpackage} || mstriplibs ${BINDIR}_${subpackage}
658     resume_stamp post-mstriplibs_${subpackage}
659     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries for '${subpackage}' ...${COLDEFAULT}"
660     run_resume post-mstripstatic_${subpackage} || mstripstatic ${BINDIR}_${subpackage}
661     resume_stamp post-mstripstatic_${subpackage}
662     fi
663    
664     # restore smage environment
665     split_restore_variables
666     done
667     # unset saved variables
668     split_unset_variables
669     else
670     echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"
671     run_resume post-mstripbins || mstripbins ${BINDIR}
672     resume_stamp post-mstripbins
673     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries ...${COLDEFAULT}"
674     run_resume post-mstriplibs || mstriplibs ${BINDIR}
675     resume_stamp post-mstriplibs
676     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries ...${COLDEFAULT}"
677     run_resume post-mstripstatic || mstripstatic ${BINDIR}
678     resume_stamp post-mstripstatic
679     fi
680    fi
681    
682  #compressing doc, info & man files  if mqueryfeature "qalint"
 echo -e "Compressing man-pages ..."  
 if [ -d ${BUILDDIR}/builded/usr/share/man ]  
683  then  then
684   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/man   if mqueryfeature "!pkgbuild"
685     then
686     echo "!pkgbuild detected; skipping QA lint checks ..."
687     else
688     if [[ -n ${SPLIT_PACKAGES} ]]
689     then
690     # save smage environment
691     split_save_variables
692     for subpackage in ${SPLIT_PACKAGES}
693     do
694     # honor split_info
695     split_info_${subpackage}
696     if [[ ${PKGTYPE} = virtual ]]
697     then
698     # automatically set !pkgbuild here too
699     msetfeature "!pkgbuild"
700     fi
701    
702     if mqueryfeature "qalint"
703     then
704     if mqueryfeature "!pkgbuild"
705     then
706     echo "!pkgbuild detected; skipping QA lint checks for '${subpackage}' ..."
707     else
708     echo -e "${COLBLUE}===${COLGREEN} running QA lint checks for '${subpackage}' ...${COLDEFAULT}"
709     mqalint ${BINDIR}_${subpackage}
710     fi
711     fi
712    
713     # restore smage environment
714     split_restore_variables
715     done
716     # unset saved variables
717     split_unset_variables
718     else
719     echo -e "${COLBLUE}===${COLGREEN} running QA lint checks ...${COLDEFAULT}"
720     mqalint ${BINDIR}
721     fi
722     fi
723  fi  fi
724    
725  echo -e "Compressing info-pages ..."  if mqueryfeature "!pkgbuild"
 if [ -d ${BUILDDIR}/builded/usr/share/info ]  
726  then  then
727   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/info   echo -e "!pkgbuild detected; Package will not be build ..."
728    else
729     # build several subpackages
730     if [[ -n ${SPLIT_PACKAGES} ]]
731     then
732     split_save_variables
733     for subpackage in ${SPLIT_PACKAGES}
734     do
735     # get the right variables for the split
736     export PNAME="${subpackage}"
737     split_info_${PNAME}
738     # fix PCATEGORIE -> PCAT
739     if [[ ! -z ${PCATEGORIE} ]]
740     then
741     PCAT="${PCATEGORIE}"
742     unset PCATEGORIE
743     fi
744     if [[ ${PKGTYPE} = virtual ]]
745     then
746     # automatically set !pkgbuild here too
747     msetfeature "!pkgbuild"
748     fi
749    
750     # jump to next one if !pkgbuild is set in split_info
751     if mqueryfeature "!pkgbuild"
752     then
753     # restore smage environment
754     split_restore_variables
755     continue
756     fi
757    
758     # check if an special subpackage_pkgbuild exists
759     if typeset -f ${PNAME}_pkgbuild > /dev/null
760     then
761     # run it
762     run_resume post-${PNAME}_pkgbuild || ${PNAME}_pkgbuild
763     resume_stamp post-${PNAME}_pkgbuild
764     fi
765     # now create the target package
766     run_resume post-pkg_builddir_${PNAME} || ${MLIBDIR}/pkgbuild_dir \
767     "${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}" \
768     "${BINDIR}_${PNAME}" || die "split_package: ${PNAME} package-build failed"
769     resume_stamp post-pkg_builddir_${PNAME}
770    
771     # build pkg-md5-sum if requested
772     run_resume post-md5sum_${PNAME} || generate_package_md5sum \
773     --pcat "${PCAT}" \
774     --pname "${PNAME}" \
775     --pver "${PVER}" \
776     --pbuild "${PBUILD}" \
777     --parch "${ARCH}"
778     resume_stamp post-md5sum_${PNAME}
779    
780     echo -e "${COLGREEN}\nPackage ${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD} successfully builded.\n${COLDEFAULT}"
781    
782     # restore smage environment
783     split_restore_variables
784     done
785     # unset all saved smage variables
786     split_unset_variables
787    
788     else
789     run_resume post-pkg_builddir || ${MLIBDIR}/pkgbuild_dir ${PKGNAME} ${BINDIR} || die "package-build failed"
790     resume_stamp post-pkg_builddir
791    
792     # build pkg-md5-sum if requested
793     run_resume post-md5sum || generate_package_md5sum \
794     --pcat "${PCAT}" \
795     --pname "${PNAME}" \
796     --pver "${PVER}" \
797     --pbuild "${PBUILD}" \
798     --parch "${ARCH}"
799     resume_stamp post-md5sum
800    
801     echo -e "${COLGREEN}\nPackage ${PKGNAME} successfully builded.\n${COLDEFAULT}"
802     fi
803    
804     # build src-pkg-tarball if requested
805     if mqueryfeature "srcpkgbuild"
806     then
807     run_resume post-srcpkgbuild || source_pkg_build ${SMAGENAME}
808     resume_stamp post-srcpkgbuild
809     fi
810  fi  fi
811    
812  #the new buildpkg command  # auto regen mage tree if requested
813  case ${NOPKGBUILD} in  regen_mage_tree
814   true|TRUE|yes|y)  
815   echo -e "NOPGKBUILD=true detected; Package will not be build ..."  if mqueryfeature "buildlog"
816   ;;  then
817   *)   bzip2 -9f ${SMAGELOGDIR}/${PKGNAME}.log
818   ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"  else
819   echo -e "\nPackage ${PKGNAME} successfully builded.\n"   [[ -f ${SMAGELOGDIR}/${PKGNAME}.log ]] && rm ${SMAGELOGDIR}/${PKGNAME}.log
820   ;;  fi
 esac  
821    
 #for sure  
 unset NOPKGBUILD  
   
822  xtitleclean  xtitleclean
 #echo -e "\nPackage ${PKGNAME} successfully builded.\n"  

Legend:
Removed from v.33  
changed lines
  Added in v.3035